#include "strdef.h"
#include "rc.h"

//EBhE
#define WIDTH 500
#define HEIGHT 300


LRESULT CALLBACK WinProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static InternalData indata;
	static MCI_STATUS_PARMS mciStatus;
	RECT rc;
	WCHAR Temp[MAX_PATH * 2];

	switch (msg) {
	case WM_DESTROY:
		DeleteInternalData(&indata);

		PostQuitMessage(0);
		return 0;

	case WM_CREATE:
		InitCommonControls();

		SetTimer(hwnd, 1, 1000, NULL);
		indata.play.dwCallback = (DWORD_PTR)hwnd;
		//gbNo[/{^/edit쐬
		indata.hTrack = CreateTrackbar(hwnd);
		indata.hButton = CreateButton(hwnd);
		return 0;
	case WM_TIMER:
		if (indata.Status)
		{
			DWORD dwSrc, dwMin, dwSrc_all, dwMin_all;
			WCHAR Temp[512];
			mciStatus.dwItem = MCI_STATUS_POSITION;
			mciSendCommandW(indata.open.wDeviceID, MCI_STATUS, MCI_STATUS_ITEM, (DWORD_PTR)&mciStatus);
			//bƕ擾
			dwSrc = (DWORD)(mciStatus.dwReturn / 1000); //msrc->src
			dwMin = dwSrc / 60;
			dwSrc %= 60;
			
			dwSrc_all = indata.maxSrc % 60;
			dwMin_all = indata.maxSrc / 60;

			swprintf_s(Temp, L"%02d:%02d", dwMin, dwSrc);

			SendMessageW(indata.hTrack, TBM_SETPOS, TRUE, mciStatus.dwReturn / 1000);
			
			SetTrackbarStatus(indata);

			SetWindowTextW(hwnd, Temp);

		}
		return 0;
	case WM_SIZE:
		GetClientRect(hwnd, &rc);
		//ɂ̓{^GAAEɂ͕b
		MoveWindow(indata.hTrack, 30, rc.bottom - 25, LOWORD(lp) - 30, 25, TRUE);
		MoveWindow(indata.hButton, 0, rc.bottom - 25, 30, 25, TRUE);
//		MoveWindow(indata.hEdit, LOWORD(lp) - 30, rc.bottom - 25, 30, 25, TRUE);
		return 0;
	case WM_NOTIFY:
		return  CustomDrawProc(hwnd, indata, wp, lp);
	case MM_MCINOTIFY:
		if (lp == indata.open.wDeviceID)
		{

			if (wp == MCI_NOTIFY_SUCCESSFUL)
			{
				//V[No[擪ɖ߂
				//Đt@CɊւ鏈
				mciSendCommandW(indata.open.wDeviceID, MCI_SEEK, MCI_SEEK_TO_START, 0);
				if (indata.NowPlay == indata.MaxPlay)
					indata.NowPlay = 0;
				else
					indata.NowPlay++;
				//̃t@C̍Đ
				DeleteInternalData_MCI(&indata);
				swprintf_s(Temp, L"%s\\%s", indata.ParentDir, indata.File[indata.NowPlay]);
				InitSoundStruct(Temp, L"MPEGVideo", &indata);
				StartPlaySound(&indata);
			}
			return 0;
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wp))
		{
		case IDM_EXIT:
			SendMessageW(hwnd, WM_DESTROY, 0, 0);
			break;
		case IDM_PLAY:
//			StartPlaySound(&indata);
			break;
		case IDM_OPEN:
			//ĐĂA폜
			DeleteInternalData(&indata);
			if (GetFileNames(hwnd, &indata))
			{
				swprintf_s(Temp, L"%s\\%s", indata.ParentDir, indata.File[0]);
				InitSoundStruct(Temp, L"MPEGVideo", &indata);
				StartPlaySound(&indata);
				//{^̐ݒ
				SetWindowTextW(indata.hButton, TEXT_BUTTON_PAUSE);
			}

			break;
		case BT_IDC_MCIBUTTON:
			//݂̃Xe[^XlĐVXe[^X蓖Ă
			if (indata.Status)
			{
				//Đ~߂
				indata.Status = FALSE;
				mciSendCommand(indata.open.wDeviceID, MCI_PAUSE, 0, 0);
				SetWindowTextW(indata.hButton, TEXT_BUTTON_PLAY);
			}
			else {
				//ĐĊJ
				if (indata.MaxPlay)
				{
					indata.Status = TRUE;
					mciSendCommandW(indata.open.wDeviceID, MCI_PLAY, MCI_NOTIFY, (DWORD_PTR)&indata.open);
					SetWindowTextW(indata.hButton, TEXT_BUTTON_PAUSE);
				}
			}
		}
	}
	return DefWindowProcW(hwnd, msg, wp, lp);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	MSG msg;
	WNDCLASS wc;
	HWND hwnd;

	OutputExeLog(L"SoundPlayerJn܂...\n");

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WinProc;
	wc.cbClsExtra = wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hCursor = wc.hIcon = NULL;
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName = L"MainWindow";
	wc.lpszMenuName = L"SOUNDPLAYER";

	if (!RegisterClassW(&wc)) 
	{
		OutputExeLog(L"Ɏs܂\n");
		return -1;
	}
	


	hwnd = CreateWindowW(wc.lpszClassName, L"MainWindow", WS_VISIBLE | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		0, 0, 400, 400, NULL, NULL, hInstance, NULL);


	if (hwnd == NULL) {
		assert(FALSE);
		return -1;
	}

	OutputExeLog(L"I\n");

	//GetMessage0-1̂ƂG[
	while (GetMessage(&msg, NULL, 0, 0) > 0) 
	{	
		DispatchMessage(&msg);
	}

	//NX
	UnregisterClass(L"test", hInstance);

	return (int)msg.wParam;

}
